SystemOrganization addCategory: #'Glamour-Seaside-Core'!
SystemOrganization addCategory: #'Glamour-Seaside-Examples'!

WAComponent subclass: #SGLComponent
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

SGLComponent subclass: #SGLCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLCodeBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/code'! !

!SGLCodeBrowser methodsFor: 'accessing' stamp: 'lr 8/25/2009 12:08'!
browser
	| browser |
	browser := GLMTableLayoutBrowser new.   

	browser row: [ :row | row column: #classes; column: #selectors ].
	browser row: #source.

	browser showOn: #classes; using: [
		browser tree
			title: 'Tree';
			children: [ :class | class subclasses ].
		browser mondrian
			title: 'Mondrian';
			painting: [ :view :class |
				view nodeShape size: 10. 
				view nodes: class withAllSubclasses.
				view edgesFrom: #superclass. 
				view treeLayout ] ].
	browser showOn: #selectors; from: #classes; using: [
		browser list 
			display: [ :class | class selectors asSortedCollection ] ].

	browser showOn: #source; from: #classes; from: #selectors; using: [
		browser text
			title: 'Source';
			when: [ :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :class :selector | class sourceCodeAt: selector ].
		browser text
			title: 'Comment';
			display: [ :class :selector | class comment ] ].
		
	^ browser! !

!SGLCodeBrowser methodsFor: 'accessing' stamp: 'lr 8/25/2009 11:28'!
model
	^ Collection! !

!SGLComponent classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 15:26'!
registerAsApplication: aString
	| application |
	application := WAAdmin register: self asApplicationAt: aString.
	application configuration
		addParent: WADevelopmentConfiguration instance;
		at: #rootDecorationClasses put: #().
	application 
		addLibrary: JQGoogleLibrary;
		addLibrary: JQUiGoogleLibrary;
		addLibrary: JQRedmondTheme.
	^ application! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 2/26/2009 20:36'!
browser
	"Override this method and answer a browser instance."
	
	self subclassResponsibility! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 6/25/2009 13:20'!
model
	"Override this method and answer a model instance."
	
	^ nil! !

!SGLComponent methodsFor: 'private' stamp: 'lr 2/27/2009 10:13'!
presentation
	presentation isNil ifTrue: [
		presentation := self browser 
			startOn: self model;
			yourself ].
	^ presentation! !

!SGLComponent methodsFor: 'rendering' stamp: 'lr 2/28/2009 13:18'!
renderContentOn: html
	(SGLRenderer in: self on: html)
		render: self presentation! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 11/6/2009 14:26'!
script
	^ 'var glamourResize = function() {
	$("body > .sgl-table").each(function() {
		$(this).height($(window).height() - 20);
	});
};

$(glamourResize);
$(window).resize(glamourResize);'! !

!SGLComponent methodsFor: 'accessing' stamp: 'lr 11/6/2009 15:02'!
style
	^ '/* html */
body {
	font-size: 0.8em;
}
html, body {
	overflow: hidden;
}
body, table, td, th, input, select, textarea, button {
	font-family: Verdana, Arial, sans-serif;
}
input, select, textarea {
	outline: 0;
	margin: 0;
	padding: 0;
	width: 100%;
	height: 100%;
	border: none;
	outline: none;
	display: block;
	background-color: transparent;
}

/* layout */
div.finder {
	width: auto;
	height: 100%;
	overflow: auto;
	overflow-x: scroll;
	overflow-y: visible;
	position: relative;
}
div.finder > div.finder-pane {
	min-width: 300px;
	max-width: 500px;
	height: auto;
	display: table-cell;
}




/* jquery ui */
.ui-tabs {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
}
.ui-tabs > .ui-tabs-nav {
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}
.ui-tabs > .ui-tabs-panel {
	padding: 0;
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

/* table layout */
.sgl-table {
	width: 100%;	
	position: relative;
}

.sgl-table-hbox, 
.sgl-table-hbox > *,
.sgl-table-vbox > * {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
	-webkit-box-orient: horizontal; -moz-box-orient: horizontal; box-orient: horizontal;
}

.sgl-table-hbox > *, 
.sgl-table-hbox > * > *,
.sgl-table-vbox > * > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.sgl-table-vbox {
	position: relative;
	display: -webkit-box; display: -moz-box; display: box;
	-webkit-box-orient: vertical; -moz-box-orient: vertical; box-orient: vertical;
	-webkit-box-align: stretch; -moz-box-align: stretch; box-align: stretch;
}

.sgl-table-vbox > * {
	-webkit-box-flex: 1; -moz-box-flex: 1; box-flex: 1;
}

.sgl-table-split {
	width: 5px; height: 5px;
	-webkit-box-flex: 0; -moz-box-flex: 0; box-flex: 0;
}

/* magritte layout */
div.magritte { width: 100%; }
div.magritte th { width: 150px; }
div.magritte textarea { height: 250px; }
div.magritte table { width: 100%; padding: .3em 1em 0 .4em; }
div.magritte input, div.magritte textarea { width: 100%; border: 1px solid #d3d3d3; background: #e6e6e6; }
div.magritte .buttons { text-align: right; border-width: 1px 0 0 0; margin: .5em 0 0 0; padding: .3em 1em .5em .4em; }
div.magritte .submit { display: inline; margin: .5em .4em .5em 0; cursor: pointer; padding: .2em .6em .3em .6em; line-height: 1.4em; width: auto; overflow: visible; border: 1px solid #d3d3d3; background: #e6e6e6 url(/seaside/files/JQUiSmoothnessTheme/uibgglass75e6e6e61x400.png) 50% 50% repeat-x; font-weight: normal; color: #555555; outline: none; }'! !

!SGLComponent methodsFor: 'updating' stamp: 'lr 2/26/2009 20:26'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Seaside Glamorous Browser'! !

SGLComponent subclass: #SGLDefaultComponent
	instanceVariableNames: ''
	classVariableNames: 'SGLBrowser SGLModel'
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLDefaultComponent classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 13:07'!
initialize
	| application |
	application := self registerAsApplication: 'glamour/pluggable'.
	application parent defaultName: application name! !

!SGLDefaultComponent classSide methodsFor: 'public' stamp: 'lr 8/25/2009 13:13'!
register: aBrowser on: aModel
	SGLBrowser := aBrowser.
	SGLModel := aModel! !

!SGLDefaultComponent methodsFor: 'accessing' stamp: 'lr 8/25/2009 13:04'!
browser
	^ SGLBrowser! !

!SGLDefaultComponent methodsFor: 'accessing' stamp: 'lr 8/25/2009 13:03'!
model
	^ SGLModel! !

SGLComponent subclass: #SGLFileBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLFileBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/file'! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'lr 2/28/2009 12:33'!
browser
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser 
		column: #folders;
		column: [ :column | column row: #files span: 2; row: #summary ] span: 2.

	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :directory | 
				directory directoryNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #files; from: #folders; using: [
		browser list
			display: [ :directory | 
				directory fileNames
					collect: [ :each | directory directoryNamed: each ] ];
			format: [ :directory | directory localName ] ].

	browser showOn: #summary; from: #files; using: [
		browser text 
			title: 'Summary';
			display: [ :directory |
				| stream |
				stream := FileStream oldFileNamed: directory pathName.
				[ (stream binary; next: 2000) asString ] 
					ensure: [ stream close ] ] ].

	^ browser! !

!SGLFileBrowser methodsFor: 'accessing' stamp: 'lr 2/27/2009 15:56'!
model
	^ FileDirectory default containingDirectory ! !

SGLComponent subclass: #SGLPierBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLPierBrowser classSide methodsFor: 'initialization' stamp: 'lr 8/25/2009 17:23'!
initialize
	self registerAsApplication: 'glamour/pier'! !

!SGLPierBrowser methodsFor: 'accessing' stamp: 'tg 5/10/2009 08:42'!
browser
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: [:c | c row: #navigation; row: #map ];
			column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [ :page | page enumerator contents ];
			format: [ :page | page title ] ].
	browser showOn: #map; using: [
		browser mondrian
			painting: [ :view :page |
				view nodeShape: (MORectangleShape new height: [ :each | each document text size // 50 + 20 ]; width: [ :each | each document text size // 50 + 20 ]).
				view nodes: page root enumerator all.
				view edgesFrom: #parent.
				view treeLayout ]
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte ].
	browser showOn: #editor; from: #map; using: [
		browser magritte ].
	^ browser ! !

!SGLPierBrowser methodsFor: 'accessing' stamp: 'lr 5/6/2009 12:44'!
model
	^ PRKernel instances anyOne root! !

SGLComponent subclass: #SGLSTPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Examples'!

!SGLSTPackageBrowser classSide methodsFor: 'as yet unclassified' stamp: 'tg 8/31/2009 17:02'!
initialize
	self registerAsApplication: 'glamour/package'! !

!SGLSTPackageBrowser methodsFor: 'as yet unclassified' stamp: 'tg 8/31/2009 17:01'!
browser
	^ GLMSTBrowserExample new browser! !

!SGLSTPackageBrowser methodsFor: 'as yet unclassified' stamp: 'tg 8/31/2009 17:01'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

!Symbol methodsFor: '*glamour-seaside' stamp: 'lr 2/25/2009 16:10'!
fixCallbackTemps! !

!WATagBrush methodsFor: '*glamour-seaside' stamp: 'lr 11/6/2009 12:32'!
boxFlex: anObject
	self style: '-webkit-box-flex: ' , anObject asString.
	self style: '-moz-box-flex: ' , anObject asString.
	self style: 'box-flex: ' , anObject asString! !

!GLMBrowser methodsFor: '*Glamour-Seaside-Scripting' stamp: 'tg 12/21/2009 12:53'!
registerInSeasideOn: aModel
	SGLDefaultComponent register: self on: aModel! !

Object subclass: #SGLRenderer
	instanceVariableNames: 'component html uuid scripts properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Core'!

!SGLRenderer classSide methodsFor: 'instance-creation' stamp: 'lr 2/26/2009 19:58'!
in: aComponent on: html
	^ self basicNew initializeIn: aComponent on: html! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 11/6/2009 11:09'!
initialize
	super initialize.
	uuid := IdentityDictionary new.
	properties := IdentityDictionary new.
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'initialization' stamp: 'lr 2/27/2009 14:45'!
initializeIn: aComponent on: aRenderer
	self initialize.
	component := aComponent.
	html := aRenderer! !

!SGLRenderer methodsFor: 'dispatching' stamp: 'lr 3/11/2009 11:20'!
render: aRenderable
	aRenderable renderGlamorouslyOn: self! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 15:34'!
renderFinder: aBrowser
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | self renderFinder: ann browser removePane: ann pane ].
	aBrowser
		when: GLMPaneAdded
		do: [ :ann | self renderFinder: ann browser addPane: ann pane ].
	html div
		id: (self uuidFor: aBrowser); 
		class: 'ui-widget'; class: 'finder';
		with: [
			aBrowser panes 
				do: [ :each | self renderFinder: aBrowser pane: each ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 14:32'!
renderFinder: aBrowser addPane: aPane
	self scriptFor: aBrowser add: ((html jQuery id: (self uuidFor: aBrowser))
		append: [ :r | html := r. self renderFinder: aBrowser pane: aPane ])! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 14:32'!
renderFinder: aBrowser pane: aPane
	html div
		class: 'finder-pane';
		with: [ self render: aPane ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 8/25/2009 14:24'!
renderFinder: aBrowser removePane: aPane
	self scriptFor: aBrowser add: ((html jQuery id: (self uuidFor: aBrowser))
		contents;
		filter: ':last';
		remove)! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/27/2009 14:56'!
renderListPresentation: aPresentation
	| items toShow |
	toShow := aPresentation displayValue.
	items := toShow isCollection
		ifTrue: [ toShow ]
		ifFalse: [ Array with: toShow ].
	html select
		size: 10;
		list: (items ifNil: [ #() ]);
		labels: aPresentation format;
		selected: aPresentation selection;
		callback: [ :value | aPresentation selection: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 5/6/2009 13:48'!
renderMagrittePresentation: aPresentation
	| form |
	form := aPresentation displayValue asComponent
		addValidatedForm;
		onAnswer: [ :answer | aPresentation selection: answer ].
	html div
		class: 'magritte';
		with: form! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 8/25/2009 16:07'!
renderMondrianPresentation: aPresentation
	| view canvas |
	view := MOViewRenderer new.
	aPresentation renderOn: view. 
	canvas := MOCanvas new. 
	canvas root: view root.
	canvas selected: (view 
		nodeForDomainValue: aPresentation selection 
		ifAbsent: [ nil ]).
	html image
		form: canvas imageForm;	
		style: 'position: relative';
		id: (self uuidFor: aPresentation);
		onClick: (html jQuery ajax 
			callback: [ :value |
			| coordinates element |
			coordinates := (value contents findTokens: $,)
				collect: [ :each | each asNumber ].
			element := canvas root elementAt: coordinates first @ coordinates second.
			aPresentation selection: (element isNil
				ifFalse: [ element model ]) ]
		value: (JSStream on: 'event.layerX+","+event.layerY');
		script: [ :script |
			self scriptFor: aPresentation put: ((html jQuery id: (self uuidFor: aPresentation))
				replaceWith: [ :r | html := r. self renderMondrianPresentation: aPresentation ]).
			self updateScript: script ])! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 12:52'!
renderPane: aPane
	aPane whenMatchingPresentationsChanged: [ :ann |
		self 
			scriptFor: aPane
			put: ((html jQuery id: (self uuidFor: aPane))
				html: [ :renderer |
					html := renderer.
					self renderPaneContent: aPane ]) ].
	self renderPaneContent: aPane! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 13:51'!
renderPane: aPane tabs: aCollection
	html div
		script: (html jQuery this tabs);
		with: [
			html unorderedList: [
				aCollection do: [ :each |
					html listItem 
						class: 'ui-state-selected' if: aPane = each;
						with: [
							html anchor
								url: (html jQuery ajax
									html: [ :renderer | 
										html := renderer.
										properties at: aPane put: each.
										self render: each ];
									fullUrl);
								with: each title ] ] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 13:51'!
renderPaneContent: aPane
	| panes pane |
	panes := aPane matchingPresentations.
	panes isEmpty 
		ifTrue: [ ^ self renderPaneEmpty ].
	panes size = 1
		ifTrue: [ ^ self renderPaneSingle: panes first ].
	pane := properties 
		at: aPane
		ifAbsentPut: [ panes first ].
	(panes includes: pane)
		ifFalse: [ pane := properties at: aPane put: panes first ].
	self renderPaneTabs: pane tabs: panes! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 13:53'!
renderPaneEmpty
	html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all'! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 15:05'!
renderPaneSingle: aPane
	html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		with: [ self render: aPane ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 15:06'!
renderPaneTabs: aPane tabs: aCollection
	html div
		script: (html jQuery this tabs);
		with: [
			html unorderedList: [
				aCollection do: [ :each |
					html listItem 
						class: 'ui-state-selected' if: aPane = each;
						with: [
							html anchor
								url: (html jQuery ajax
									html: [ :renderer | 
										html := renderer.
										properties at: aPane put: each.
										self render: each ];
									fullUrl);
								with: each title ] ] ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 2/27/2009 14:14'!
renderTableLayoutBrowser: aBrowser
	aBrowser cell isRow
		ifTrue: [ self renderTableLayoutBrowserRow: aBrowser cell ]
		ifFalse: [ self renderTableLayoutBrowserColumn: aBrowser cell ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 14:30'!
renderTableLayoutBrowserColumn: aCell
	html div class: 'sgl-table'; class: 'sgl-table-vbox'; with: [
		aCell children 
			do: [ :each |
				| tag |
				tag := html div boxFlex: each span; style: 'position: relative;'.
				each hasId 
					ifTrue: [
						| pane |
						pane := aCell browser paneNamed: each id.
						tag id: (self uuidFor: pane); with: [ self render: pane ] ]
					ifFalse: [ 
						tag with: [ self renderTableLayoutBrowserRow: each ] ] ]
			separatedBy: [ html div class: 'sgl-table-split' ] ]! !

!SGLRenderer methodsFor: 'widgets' stamp: 'lr 11/6/2009 14:30'!
renderTableLayoutBrowserRow: aCell
	html div class: 'sgl-table'; class: 'sgl-table-hbox'; with: [
		aCell children 
			do: [ :each |
				| tag |
				tag := html div boxFlex: each span; style: 'position: relative;'.
				each hasId 
					ifTrue: [
						| pane |
						pane := aCell browser paneNamed: each id.
						tag id: (self uuidFor: pane); with: [ self render: pane ] ]
					ifFalse: [ 
						tag with: [ self renderTableLayoutBrowserColumn: each ] ] ]
			separatedBy: [ html div class: 'sgl-table-split' ] ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 3/11/2009 11:35'!
renderTextPresentation: aPresentation
	html textArea
		value: aPresentation formatedDisplayValue;
		callback: [ :value | aPresentation text: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ])! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/27/2009 15:51'!
renderTreePresentation: aPresentation
	| tag nodes |
	(tag := html select)
		size: 10;
		selected: aPresentation selection;
		callback: [ :value | aPresentation selection: value ];
		onChange: (html jQuery ajax 
			serializeThis;
			script: [ :script | self updateScript: script ]);
		with: [
			nodes := aPresentation displayValue.
			nodes isCollection
				ifFalse: [ nodes := Array with: nodes ].
			nodes do: [ :each |
				self 
					renderTreePresentation: aPresentation
					select: tag node: each level: 0 ] ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 2/28/2009 13:22'!
renderTreePresentation: aPresentation select: aSelectTag node: anObject level: anInteger
	html option
		selected: (aSelectTag isSelected: anObject);
		callback: [ aSelectTag performCallback: anObject ];
		with: [
			anInteger timesRepeat: [ html html: '&nbsp;' ].
			html text: (aPresentation format value: anObject) ].
	(aPresentation children value: anObject)
		do: [ :each | self renderTreePresentation: aPresentation select: aSelectTag node: each level: anInteger + 4 ]! !

!SGLRenderer methodsFor: 'presentation' stamp: 'lr 3/11/2009 11:25'!
renderWorkspacePresentation: aWorkspacePresentation
	self renderTextPresentation: aWorkspacePresentation! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 8/25/2009 14:20'!
scriptFor: anObject add: aScript
	(scripts at: (self uuidFor: anObject) ifAbsentPut: [ JSScript new ]) , aScript! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 8/25/2009 14:04'!
scriptFor: anObject put: aScript
	scripts at: (self uuidFor: anObject) put: aScript! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 11/6/2009 11:18'!
updateScript: aScript
	aScript addAll: scripts values.
	aScript add: (JSStream on: 'glamourResize()').
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'private' stamp: 'lr 2/27/2009 14:54'!
uuidFor: anObject
	^ uuid at: anObject ifAbsentPut: [ html nextId ]! !
SGLCodeBrowser initialize!
SGLDefaultComponent initialize!
SGLFileBrowser initialize!
SGLPierBrowser initialize!
SGLSTPackageBrowser initialize!
